
	; Different Sounds for each Yoshi Coin
	; ------------------------------------

	; This makes collecting a Yoshi/Dragon Coin play a different sound
	; depending on how many you already have.

	; Based on imamelia's Yoshi Coin Fix patch (http://www.smwcentral.net/?p=section&a=details&id=4149)
	; so that those fixes are included.


	!FreeSpace	= $000000	; Free ROM space, change this

	!CoinsToGive	= 1		; How many regular coins a Yoshi coin gives

	!Sound1		= $2B		; What sounds to play for each Yoshi Coin
	!Sound2		= $2C		; (the last one is played when you have six or more)
	!Sound3		= $2D
	!Sound4		= $2E
	!Sound5		= $2F
	!Sound6andMore	= $2F

	!Bank		= $1DF9		; The bank to use ($1DF9 or $1DFC)

	; ------------------------------------

header
lorom


org $00F332
	CPY #$2D
	BCC $31
	PHY
	JSL $00F377
	INC $1422
	LDA $1422
	CMP #$05
	BCC +
	PHX
	JSR $F3B2
	ORA $1F2F,y
	STA $1F2F,y
	PLX
+	JSL PlaySound
	NOP

	LDA.b #!CoinsToGive
	JSL $05B330
	LDA #$01
	STA $9C
	JSL $00BEB0
	JML NewGen

	; ----------

org !FreeSpace
db "STAR"
dw End-Start-1 : dw End-Start-1^$FFFF
print " Inserted at $",pc
reset bytes

Start:
NewGen:
	LDA #$01
	STA $9C
	JSL $00BEB0
	PLY
	REP #$20
	LDA $98
	CPY #$2D
	BNE .notTopTile
	CLC : ADC.w #$0010
	BRA .setY
.notTopTile
	SEC
	SBC.w #$0010
.setY
	STA $98
	SEP #$20
	LDA #$01
	STA $9C
	JSL $00BEB0
	JML $00F373


	; ---


PlaySound:
	PHX
	LDX $1422
	CPX #$06
	BCS .morethan5
	DEX
	LDA.l .sounds,x
	BRA +
.morethan5
	LDA.b #!Sound6andMore
+
	STA.w !Bank
	PLX
	RTL

.sounds
	db !Sound1,!Sound2,!Sound3,!Sound4,!Sound5

End:



print " ",bytes," bytes of free space used."